@ECHO off

call patch_env.bat
SET SILENT=false
IF "%1a"=="a" GOTO no_param
IF NOT EXIST %1\License ECHO ****** Could not find directory %1\License ******
IF NOT EXIST %1\License GOTO no_param
SET ITM_HOME=%1
IF NOT "%2a"=="a" SET SILENT=true
GOTO checkPrerequisite

:no_param
ECHO You did not specify your ITM installation path
ECHO Try to use the default one - C:\IBM\ITM
set ITM_HOME=C:\IBM\ITM
IF not EXIST %ITM_HOME%\License  ECHO Could not find directory %ITM_HOME%\License, press any key ...
IF not EXIST %ITM_HOME% GOTO queryITM
ECHO Would you confirm the default location '%ITM_HOME%' is the right place for install? (Y/N)
SET /P useDefaultITM=
IF /I "%useDefaultITM%"=="y" goto checkPrerequisite

:queryITM
pause
ECHO Please input your ITM folder:
SET /P ITM_HOME=
IF not EXIST %ITM_HOME%\License  ECHO Could not find directory %ITM_HOME%\License
IF not EXIST %ITM_HOME%\License  GOTO queryITM
GOTO checkPrerequisite

:checkPrerequisite
%ITM_HOME%\InstallITM\KinCInfo.exe -i > info
echo CF >comp
echo IC >>comp
echo IE >>comp
echo MC >>comp
echo MQ >>comp
echo QI >>comp
set MyVar=
setlocal ENABLEDELAYEDEXPANSION
FOR /F  %%j IN (comp) DO (
	FIND "%%j    " <info >match
	set /p MyVar= <match
	IF NOT "!MyVar!a"=="a" goto getMsgVersion 
)

:getMsgVersion
set FOUND=
set VER=
FOR /F "delims=!" %%i IN (info) DO (if  "%MyVar%" == "%%i" ( set FOUND=123) ELSE ( if "!FOUND!" == "123" SET FOUND=%%i ))
ECHO !FOUND! >version
FOR /F "tokens=3 delims= " %%i IN (version) DO SET VER=%%i
SET "VER=%VER:.=%"
SET "VER=%VER: =%"
SET VER=%VER:~0,-2%
@del /Q version
@del /Q match
@del /Q comp

IF NOT "%VER%"=="%PREREQUISITE%" echo The current version is %VER%, the prerequisite is %PREREQUISITE%%, can not install this patch
IF NOT "%VER%"=="%PREREQUISITE%" goto endpro

:genUninstall
SET uninst=patch_uninstall.bat
SET missed=no
IF EXIST %uninst% DEL %uninst%
IF EXIST backup RD /s /q backup
MD backup
MD backup\InstallITM
MD backup\InstallITM\ver

SET ITMVER=
IF NOT EXIST %ITM_HOME%\InstallITM\ver (ECHO ******CAN NOT FIND VERSION INFO******)
echo MS >comp
echo CW >>comp
echo CJ >>comp
echo CQ >>comp
echo GL >>comp
echo OS >>comp
echo UA >>comp
set MyVar=
setlocal ENABLEDELAYEDEXPANSION
FOR /F  %%j IN (comp) DO (
	FIND "%%j    " <info >match
	set /p MyVar= <match
	IF NOT "!MyVar!a"=="a" goto getITMVersion 
)

:getITMVersion
set FOUND=
set VER=
FOR /F "delims=!" %%i IN (info) DO (if  "%MyVar%" == "%%i" ( set FOUND=123) ELSE ( if "!FOUND!" == "123" SET FOUND=%%i ))
ECHO %FOUND% >info
FOR /F "tokens=2 delims=." %%i IN (info) DO SET VER=%%i
REM IF "%VER%" == "20" SET ITMVER=ITM62
REM IF "%VER%" == "10" SET ITMVER=ITM61
@del /Q info
@del /Q match
@del /Q comp

REM ECHO %ITMVER% is found under %ITM_HOME% 
REM IF EXIST %ITMVER%\file_list.txt TYPE %ITMVER%\file_list.txt >>file_list.txt
REM move file_list.txt file_list.txt.bak
REM @XCOPY /E /Y %ITMVER%\* .
REM move file_list.txt.bak file_list.txt
if not exist file_list.txt (
echo "Not found file_list.txt"
goto endpro )

SET KMQAGENT=false
SET KQIAGENT=false
SET KMCAGENT=false
if exist ctrlagent.exe (
    IF EXIST %ITM_HOME%\TMAITM6\kmqagent.exe (SET KMQAGENT=true)
    IF EXIST %ITM_HOME%\TMAITM6_x64\kmqagent.exe (SET KMQAGENT=true)
    IF EXIST %ITM_HOME%\TMAITM6\kqiagent.exe (SET KQIAGENT=true)
    IF EXIST %ITM_HOME%\TMAITM6_x64\kqiagent.exe (SET KQIAGENT=true)
    IF EXIST %ITM_HOME%\TMAITM6\kmcrca.exe   (SET KMCAGENT=true)
    IF EXIST %ITM_HOME%\TMAITM6_x64\kmcrca.exe   (SET KMCAGENT=true)
)

set logfile="Installation_Log.log"
set unlogfile="Uninstallation_Log.log"
echo *********************************%date% %time%********************************* >> %logfile%

set kmsver="%ITM_HOME%\InstallITM\ver\KMSWICMS.ver"
IF not EXIST "%kmsver%" goto skipKCF
:: on win32 copy the 32bit dll from CMSx32 to CMS
for /f "delims=" %%t in ('type "%kmsver%" ^| find "PlatformArch="') do set PlatformStr=%%t
echo "%PlatformStr%" >> %logfile% 
if "%PlatformStr%" == "PlatformArch=WINNT" (
if EXIST CMSx32 (
    xcopy /I /E /Y CMSx32 CMS >> %logfile%
    if %ERRORLEVEL% == 0 echo "XCOPY CMSx32 to CMS" >> %logfile%
) else ( 
    echo "CMSx32 does not exists" >> %logfile%
)
)
:skipKCF


echo Backup old files >> %logfile%
ECHO Backup old files
IF NOT "%SILENT%"=="true" PAUSE
REM @XCOPY /E /I %ITM_HOME%\CNB backup\CNB
REM if %ERRORLEVEL% == 0 (echo XCopy %ITM_HOME%\CNB to backup\CNB Done >> %logfile% ) else ( echo Copy %ITM_HOME%\CNB to backup\CNB Failure, Error Code: %ERRORLEVEL% >> %logfile% )
REM @XCOPY /E /I %ITM_HOME%\CNP backup\CNP
REM if %ERRORLEVEL% == 0 (echo XCopy %ITM_HOME%\CNP to backup\CNP Done >> %logfile% ) else ( echo Copy %ITM_HOME%\CNP to backup\CNP Failure, Error Code: %ERRORLEVEL% >> %logfile% )
REM @XCOPY /E /I %ITM_HOME%\CNPS backup\CNPS
REM if %ERRORLEVEL% == 0 (echo XCopy %ITM_HOME%\CNPS to backup\CNPS Done >> %logfile% ) else ( echo Copy %ITM_HOME%\CNPS to backup\CNPS Failure, Error Code: %ERRORLEVEL% >> %logfile% )
REM @XCOPY /E /I %ITM_HOME%\CMS backup\CMS
REM if %ERRORLEVEL% == 0 (echo XCopy %ITM_HOME%\CMS to backup\CMS Done >> %logfile% ) else ( echo Copy %ITM_HOME%\CMS to backup\CMS Failure, Error Code: %ERRORLEVEL% >> %logfile% )
REM @XCOPY /E /I %ITM_HOME%\TMAITM6 backup\TMAITM6
REM if %ERRORLEVEL% == 0 (echo XCopy %ITM_HOME%\TMAITM6 to backup\TMAITM6 Done >> %logfile% ) else ( echo Copy %ITM_HOME%\TMAITM6 to backup\TMAITM6 Failure, Error Code: %ERRORLEVEL% >> %logfile% )
REM @XCOPY /E /I %ITM_HOME%\InstallITM backup\InstallITM
REM if %ERRORLEVEL% == 0 (echo XCopy %ITM_HOME%\InstallITM to backup\InstallITM Done >> %logfile% ) else ( echo Copy %ITM_HOME%\InstallITM to backup\InstallITM Failure, Error Code: %ERRORLEVEL% >> %logfile% )
REM @XCOPY /E /I %ITM_HOME%\Config backup\Config
REM if %ERRORLEVEL% == 0 (echo XCopy %ITM_HOME%\Config to backup\Config Done >> %logfile% ) else ( echo Copy %ITM_HOME%\Config to backup\Config Failure, Error Code: %ERRORLEVEL% >> %logfile% )
ECHO Backup to be installed files >> %logfile%

FOR /F %%i IN (file_list.txt) DO ( 
IF EXIST %ITM_HOME%\%%i (
ECHO F | xcopy /I /E /Y %ITM_HOME%\%%i backup\%%i >> %logfile%
if !ERRORLEVEL! == 0 (
echo XCopy %ITM_HOME%\%%i to backup\%%i Done
echo XCopy %ITM_HOME%\%%i to backup\%%i Done >> %logfile% 
) else ( 
echo Copy %ITM_HOME%\%%i to backup\%%i Failure, Error Code: !ERRORLEVEL!
echo Copy %ITM_HOME%\%%i to backup\%%i Failure, Error Code: !ERRORLEVEL! >> %logfile%
) ) ELSE ( 
SET missed=yes 
echo missed %ITM_HOME%\%%i >> %logfile% 
) )

REM  BACKUP VERSION FILES
ECHO Backup version files
FOR /F %%i IN (version_files.txt) DO ( 
IF EXIST %ITM_HOME%\%%i ( 
ECHO Copying %ITM_HOME%\%%i
copy /V /Y %ITM_HOME%\%%i backup\%%i
if !ERRORLEVEL! == 0 (echo XCopy %ITM_HOME%\%%i to backup\%%i Done >> %logfile% ) else ( echo Copy %ITM_HOME%\%%i to backup\%%i Failure, Error Code: !ERRORLEVEL! >> %logfile% ) 
)
)

if not exist backup_original (
echo copy backup files to backup_original >> %logfile%
XCOPY /E /I /Y /Q backup backup_original >> %logfile%
)

ECHO Generate uninstall
IF NOT "%SILENT%"=="true" PAUSE
ECHO @echo off > %uninst%
ECHO rem This is generated by patch_install.bat >> %uninst%
ECHO rem This batch file could retore your original modules from an interim fix installation >> %uninst%
ECHO rem Please do not modify this file >> %uninst%
ECHO echo *********************************%%date%% %%time%%********************************* ^>^> %unlogfile% >> %uninst%
ECHO echo Uninstall ifix pack. Restore old files. ^>^> %unlogfile% >> %uninst%  
FOR /F %%i IN (file_list.txt) DO ( 
IF EXIST %ITM_HOME%\%%i ( 
ECHO XCOPY /Y backup\%%i %ITM_HOME%\%%i >> %uninst% 
ECHO if %%ERRORLEVEL%% == 0 ( echo XCopy %%i to %ITM_HOME%\%%i Done ^>^> %unlogfile% ^) else ( echo Copy %%i to %ITM_HOME%\%%i Failure, Error Code: %%ERRORLEVEL%% ^>^> %unlogfile% ^) >> %uninst%
) 
)
REM Restore agent instances files
IF "%KMQAGENT%"=="true" ( ECHO ctrlagent.exe update kmq -a %ITM_HOME% ^>^> %unlogfile% 2^>^&1 >> %uninst%)
IF "%KQIAGENT%"=="true" ( ECHO ctrlagent.exe update kqi -a %ITM_HOME% ^>^> %unlogfile% 2^>^&1 >> %uninst%)
IF "%KMCAGENT%"=="true" ( ECHO ctrlagent.exe update kmc -a %ITM_HOME% ^>^> %unlogfile% 2^>^&1 >> %uninst%)

REM UNINSTALL VERSION FILES
FOR /F %%i IN (version_files.txt) DO ( 
IF EXIST %ITM_HOME%\%%i ( 
ECHO COPY /Y /V backup\%%i %ITM_HOME%\%%i >> %uninst% 
ECHO if %%ERRORLEVEL%% == 0 ( echo Copy %%i to %ITM_HOME%\%%i Done ^>^> %unlogfile% ^) else ( echo Copy %%i to %ITM_HOME%\%%i Failure, Error Code: %%ERRORLEVEL%% ^>^> %unlogfile% ^) >> %uninst%
) 
)
:: new_files.txt is no longer used, skip it.
goto skip_newfiles
SET dependency=
SETLOCAL EnableDelayedExpansion
FOR /F %%i IN (new_files.txt) DO (
	IF NOT "%%i"=="--" (
		IF "!dependency!"=="" (
			IF EXIST %ITM_HOME%\%%i (
				SET dependency=yes
			) ELSE (
				SET dependency=no
			)
		) ELSE (
			IF "!dependency!"=="yes" (
				ECHO DEL /Q %ITM_HOME%\%%i >> %uninst%
			)
			
		)
	) ELSE (
		SET dependency=
	)
)
ENDLOCAL
:skip_newfiles
ECHO echo Uninstall finished. Please check %unlogfile% for details. >> %uninst%
GOTO startInst

:startInst
set i=
set replaced=0
ECHO We are going to install the interim fix to the directory %ITM_HOME%
ECHO If you don't want that or IF this is not correct, press CTRL-BREAK now.
IF NOT "%SILENT%"=="true" PAUSE
ECHO Ok, we're going...
echo Start installation >> %logfile%
FOR /F %%i IN (file_list.txt) DO ( 
IF EXIST %ITM_HOME%\%%i ( 
xcopy /Y %%i %ITM_HOME%\%%i
if !ERRORLEVEL! == 0 (
echo XCopy %%i to %ITM_HOME%\%%i Done >> %logfile%
set /a replaced=!replaced!+1 
) else ( echo Copy %%i to %ITM_HOME%\%%i Failure, Error Code: !ERRORLEVEL! >> %logfile%)
) ELSE ( 
SET missed=yes  
echo missed %%i %ITM_HOME%\%%i >> %logfile% )
)
echo %replaced% files replaced in total. 
echo %replaced% files replaced in total. >> %logfile%
:: new_files.txt is no longer used. skip it
goto replace
SET dependency=
SETLOCAL EnableDelayedExpansion
FOR /F %%i IN (new_files.txt) DO (
	IF NOT "%%i"=="--" (
		IF "!dependency!"=="" (
			IF EXIST %ITM_HOME%\%%i (
				SET dependency=yes
			) ELSE (
				SET dependency=no
			)
		) ELSE (
			IF "!dependency!"=="yes" (
				ECHO %%i
				@COPY /Y %%i %ITM_HOME%\%%i 
			)
		)
	) ELSE (
		SET dependency=
	)
)
ENDLOCAL


:replace
if %replaced% EQU 0 goto no_replace
echo update from old version to new version
echo update from old version to new version >> %logfile%
SET OLDVERSION=%IFIX_LEVEL:~0,-2%
set oldver="VRMF=%OLDVERSION%**"
set newver="VRMF=%IFIX_LEVEL%"
set old_BUILD_DATE="Build=*"
set new_BUILD_DATE="Build=%BUILD_DATE%"
FOR /F %%i IN (version_files.txt) DO (
	IF EXIST %ITM_HOME%\%%i (
		replace %ITM_HOME%\%%i tmp %oldver% %newver%
        if !ERRORLEVEL! == 0 (echo update version file %ITM_HOME%\%%i Done >> %logfile% )
		if "!errorlevel!" == "1" (
			@copy /Y /V  tmp %ITM_HOME%\%%i
		)
		@del /Q tmp
		replace %ITM_HOME%\%%i tmp %old_BUILD_DATE% %new_BUILD_DATE%
		if "!errorlevel!" == "1" (
			@copy /Y /V  tmp %ITM_HOME%\%%i
		)
		@del /Q tmp
	)
)

goto result

:result
set i=
echo *************************************************************
echo *************************************************************
::IF %missed%==yes ECHO Below file(s) were not copied during this installation.
::IF %missed%==yes ECHO Installer did not find those files in the directory. This might be correct if the related components were not installed in the environment.
::IF %missed%==yes ( For /F %%i IN (file_list.txt) DO ( IF NOT EXIST %ITM_HOME%\%%i ECHO %%i ) )
::IF %missed%==yes ECHO *************************************************************
::IF %missed%==yes ECHO *************************************************************

REM ECHO Sync with agent instances
ECHO Sync with agent instances
ECHO Sync with agent instances >> %logfile%
IF "%KMQAGENT%"=="true" ( ctrlagent.exe update kmq -a %ITM_HOME% >> %logfile% 2>&1)
IF "%KQIAGENT%"=="true" ( ctrlagent.exe update kqi -a %ITM_HOME% >> %logfile% 2>&1)
IF "%KMCAGENT%"=="true" ( ctrlagent.exe update kmc -a %ITM_HOME% >> %logfile% 2>&1)
goto install_complete

:no_replace
echo No file was replace. Please check your ITM Home. This might be correct if the related components were not installed in the environment.

:install_complete
ECHO Install complete
echo Install complete >> %logfile%
goto endpro

rem :errorend
rem ECHO ERROR! Program is ending ...
rem GOTO endpro

:endpro
